% Exhaustive Search

% clear all
% for NNN=[500 1000 2000]
%     exhaustive(NNN)
% end

function exhaustive(NNN)
% clear all
close all
clc
format long

% load er_500_nets
load(['dt_',num2str(NNN),'_nets.mat']);

ln=length(rA);
nLabels=1:N;
O=zeros(ln,23);

ln=1;
for n=1:ln
    
    E=rE{n};    % distances
    A=rA{n};    % adjacency matrix
    W=rW{n};    % weighted adjacency matrix
    D=rD{n};    % shortest network distances between each point pair
    DS=rDS{n};  % shortest network distance from each point to focal node
    ND=rND{n};  % set of distant nodes
    NC=rNC{n};  % set of close nodes
    DC=rDC{n};  % degree of each node
    CC=rCC{n};  % closeness centrality of each node
    BC=rBC{n};  % betweenness centrality of each node
    EC=rEC{n};  % eigenvector centrality of each node
    PR=rPR{n};  % pagerank of each node
    F=rF{n};    % focal node index
    T=rT{n};    % threshold
    KC=rKC{n};
    NM=rNM{n};
    KG=rKG{n};
    
    tic
    % exhaustive search algorithm
    k=1;
    for i=ND'
        SS=NC(find(E(i,NC)+DS(NC)'<=T))';
        for j=SS
            CB(k,1)=i;
            CB(k,2)=j;
            CB(k,3)=E(i,j);
            Ap=A;
            Ap(i,j)=1;
            Ap(j,i)=1;
            DSp=distances(graph(Ap.*E),nLabels,F);
            CB(k,4)=length(find(DSp<=T))-length(find(DS<=T));
            k=k+1;
        end
    end
    t=toc;
    
    o=CB(find(CB(:,4)==max(CB(:,4))),:);
    if length(o)>1
        o=o(find(o(:,3)==min(o(:,3))),:);
        o=o(1,:);
    end
    
    AE{n}=[CB DC(CB(:,1)) DC(CB(:,2)) CC(CB(:,1)) CC(CB(:,2)) BC(CB(:,1)) BC(CB(:,2)) EC(CB(:,1)) EC(CB(:,2)) PR(CB(:,1)) PR(CB(:,2)) DS(CB(:,1)) DS(CB(:,2)) KC(CB(:,1)) KC(CB(:,2)) NM(CB(:,1)) NM(CB(:,2)) KG(CB(:,1)) KG(CB(:,2))];

    O(n,:)=[t o(1) o(2) o(3) o(4) DC(o(1)) DC(o(2)) CC(o(1)) CC(o(2)) BC(o(1)) BC(o(2)) EC(o(1)) EC(o(2)) PR(o(1)) PR(o(2)) DS(o(1)) DS(o(2)) KC(o(1)) KC(o(2)) NM(o(1)) NM(o(2)) KG(o(1)) KG(o(2))];
    
    [n t o(3) o(4)]
    
end

save(['dt_',num2str(N),'_opt.mat'],'O');
save(['dt_',num2str(N),'_all_sols.mat'],'AE');

