
% optimizing new connections for school residence networks
% 18 Nov 2017

close all
clear all
clc

format long

% load node spatial positions
P=csvread('test_node_loc.csv');

% load sparse adjacency matrix
load('test_adj_mat.mat')

% convert to full matrix
S=adj_matrix;
A=full(S);
A=A+A';
A(A>1)=1;

% pairwise Euclidean distances
E=pdist2(P,P);

fghf

% weighted adjacency matrix
W=A.*E;

% create graph
G=graph(W);

% create graph plot
nLabels=1:length(A);
%plot(G,'XData',P(:,1),'YData',P(:,2),'NodeLabel',nLabels)
%plot(G,'XData',P(:,1),'YData',P(:,2))

% Amherst is node 431 !!!!!!!!!!

% shortest network distances between all node pairs
D=distances(G);

T=5280;  % threshold distance
% shortest network distances between all nodes and school
DS=distances(G,nLabels,431);

% set of distant nodes
ND=find(DS>T);

% set of close nodes
NC=find(DS<=T);

r=100;
tic
% exhaustive search algorithm
k=1;
for i=ND'
    SS=NC(find(E(i,NC)+DS(NC)'<=T))';
    for j=SS
        CB(k,1)=i;
        CB(k,2)=j;
        CB(k,3)=E(i,j);
        Ap=A;
        Ap(i,j)=1;
        Ap(j,i)=1;
        DSp=distances(graph(Ap.*E),nLabels,431);
        CB(k,4)=length(find(DSp<=T))-length(find(DS<=T));
        k=k+1;
    end
end
t=toc



save amherst_ex
